2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see https://www.gnu.org/licenses/ .
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19 echo "Error: The notmuch test suite requires a bash version >= 4.0"
20 echo "due to use of associative arrays within the test suite."
21 echo "Please try again with a newer bash (or help us fix the"
22 echo "test suite to be more portable). Thanks."
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34 echo >&2 'You do not seem to have built notmuch yet.'
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
46 # do not redirect again
48 *' --tee '*|*' --va'*)
50 BASE=test-results/$this_test
51 (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52 echo $? > $BASE.exit) | tee $BASE.out
53 test "$(cat $BASE.exit)" = 0
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
61 # Save STDOUT to fd 6 and STDERR to fd 7.
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
67 # Keep the original TERM for say_color and test_emacs
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
80 # For repeatability, reset the environment to known value.
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89 ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90 echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
111 unset ALTERNATE_EDITOR
113 # for reproducibility
118 [ -e "${GNUPGHOME}/gpg.conf" ] && return
119 _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
120 at_exit_function _gnupg_exit
121 mkdir -p -m 0700 "$GNUPGHOME"
122 gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
123 test_debug "cat $GNUPGHOME/import.log"
124 if (gpg --quick-random --version >/dev/null 2>&1) ; then
125 echo quick-random >> "$GNUPGHOME"/gpg.conf
126 elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
127 echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
129 echo no-emit-version >> "$GNUPGHOME"/gpg.conf
131 # Change this if we ship a new test key
132 FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
133 SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
134 SELF_EMAIL="test_suite@notmuchmail.org"
135 printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
139 test_require_external_prereq openssl
142 [ -e "$GNUPGHOME/gpgsm.conf" ] && return
143 _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
144 at_exit_function _gnupg_exit
145 mkdir -p -m 0700 "$GNUPGHOME"
146 openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
147 < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
148 gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
149 --disable-dirmngr --import >"$GNUPGHOME"/import.log 2>&1 3<<<''
150 fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
151 echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
152 gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
153 echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
154 printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
155 gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
156 --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
157 test_debug "cat $GNUPGHOME/import.log"
160 # Each test should start with something like this, after copyright notices:
162 # test_description='Description of this test...
163 # This test checks if command xyzzy does the right thing...
165 # . ./test-lib.sh || exit 1
169 while test "$#" -ne 0
175 immediate=t; shift ;;
183 with_dashes=t; shift ;;
190 valgrind=t; verbose=t; shift ;;
192 shift ;; # was handled already
194 echo "error: unknown test option '$1'" >&2; exit 1 ;;
198 if test -n "$debug"; then
200 printf -v $1 " %-4s" "[$((test_count - 1))]"
208 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
210 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] &&
211 tput -T "$ORIGINAL_TERM" -S <<<$'bold\nsetaf\nsgr0\n' >/dev/null 2>&1
220 # _tput run in subshell (``) only
221 _tput () { exec tput -T "$ORIGINAL_TERM" "$@"; }
222 unset BOLD RED GREEN BROWN SGR0
225 error) b=${BOLD=`_tput bold`}
226 c=${RED=`_tput setaf 1`} ;; # bold red
227 skip) b=${BOLD=`_tput bold`}
228 c=${GREEN=`_tput setaf 2`} ;; # bold green
229 pass) b= c=${GREEN=`_tput setaf 2`} ;; # green
230 info) b= c=${BROWN=`_tput setaf 3`} ;; # brown
231 *) b= c=; test -n "$quiet" && return ;;
235 sgr0=${SGR0=`_tput sgr0`}
237 printf " ${b}${c}${f}${sgr0}${st}" "$@"
241 test -z "$1" && test -n "$quiet" && return
245 printf " ${f}${st}" "$@"
250 say_color error "error: $*\n"
259 test "${test_description}" != "" ||
260 error "Test script did not set test_description."
262 if test "$help" = "t"
264 echo "Tests ${test_description}"
268 test_description_printed=
269 print_test_description () {
270 test -z "$test_description_printed" || return 0
272 echo $this_test: "Testing ${test_description}"
273 test_description_printed=1
275 if [ -z "$NOTMUCH_TEST_QUIET" ]
277 print_test_description
286 declare -a _exit_functions=()
288 at_exit_function () {
289 _exit_functions=($1 ${_exit_functions[@]/$1})
292 rm_exit_function () {
293 _exit_functions=(${_exit_functions[@]/$1})
300 for _fn in ${_exit_functions[@]}; do $_fn; done
301 rm -rf "$TEST_TMPDIR"
306 if test -n "$GIT_EXIT_OK"
311 say_color error '%-6s' FATAL
312 echo " $test_subtest_name"
314 echo "Unexpected exit while executing $0. Exit code $code."
321 echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
328 say_color error '%-6s' FATAL
331 echo "Unexpected exit while executing $0."
336 # Note: TEST_TMPDIR *NOT* exported!
337 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
338 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
339 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
340 trap 'trap_exit' EXIT
341 trap 'trap_signal' HUP INT TERM
343 # Add an existing, fixed corpus of email to the database.
345 # $1 is the corpus dir under corpora to add, using "default" if unset.
347 # The default corpus is based on about 50 messages from early in the
348 # history of the notmuch mailing list, which allows for reliably
349 # testing commands that need to operate on a not-totally-trivial
350 # number of messages.
351 add_email_corpus () {
356 cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
357 notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
360 test_begin_subtest () {
361 if [ -n "$inside_subtest" ]; then
362 exec 1>&6 2>&7 # Restore stdout and stderr
363 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
365 test_subtest_name="$1"
367 # Redirect test output to the previously prepared file descriptors
368 # 3 and 4 (see below)
369 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
374 # Pass test if two arguments match
376 # Note: Unlike all other test_expect_* functions, this function does
377 # not accept a test name. Instead, the caller should call
378 # test_begin_subtest before calling this function in order to set the
380 test_expect_equal () {
381 local output expected testname
382 exec 1>&6 2>&7 # Restore stdout and stderr
383 if [ -z "$inside_subtest" ]; then
384 error "bug in the test script: test_expect_equal without test_begin_subtest"
388 error "bug in the test script: not 2 parameters to test_expect_equal"
392 if ! test_skip "$test_subtest_name"
394 if [ "$output" = "$expected" ]; then
397 testname=$this_test.$test_count
398 echo "$expected" > $testname.expected
399 echo "$output" > $testname.output
400 test_failure_ "$(diff -u $testname.expected $testname.output)"
405 # Like test_expect_equal, but takes two filenames.
406 test_expect_equal_file () {
407 local file1 file2 testname basename1 basename2
408 exec 1>&6 2>&7 # Restore stdout and stderr
409 if [ -z "$inside_subtest" ]; then
410 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
414 error "bug in the test script: not 2 parameters to test_expect_equal_file"
418 if ! test_skip "$test_subtest_name"
420 if diff -q "$file1" "$file2" >/dev/null ; then
423 testname=$this_test.$test_count
424 basename1=`basename "$file1"`
425 basename2=`basename "$file2"`
426 cp "$file1" "$testname.$basename1"
427 cp "$file2" "$testname.$basename2"
428 test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
433 # Like test_expect_equal, but arguments are JSON expressions to be
434 # canonicalized before diff'ing. If an argument cannot be parsed, it
435 # is used unchanged so that there's something to diff against.
436 test_expect_equal_json () {
437 local script output expected
438 # The test suite forces LC_ALL=C, but this causes Python 3 to
439 # decode stdin as ASCII. We need to read JSON in UTF-8, so
440 # override Python's stdio encoding defaults.
441 script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
442 output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
444 expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
447 test_expect_equal "$output" "$expected" "$@"
450 # Ensure that the argument is valid JSON data.
452 PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
453 test_expect_equal "$?" 0
456 # Sort the top-level list of JSON data from stdin.
458 PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
459 "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
462 # test for json objects:
463 # read the source of test/json_check_nodes.py (or the output when
464 # invoking it without arguments) for an explanation of the syntax.
467 exec 1>&6 2>&7 # Restore stdout and stderr
468 if [ -z "$inside_subtest" ]; then
469 error "bug in the test script: test_json_eval without test_begin_subtest"
473 error "bug in the test script: test_json_nodes needs at least 1 parameter"
475 if ! test_skip "$test_subtest_name"
477 output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
482 test_failure_ "$output"
488 notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
491 NOTMUCH_DUMP_TAGS () {
492 # this relies on the default format being batch-tag, otherwise some tests will break
493 notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
496 notmuch_drop_mail_headers () {
499 msg = email.message_from_file(sys.stdin)
500 for hdr in sys.argv[1:]: del msg[hdr]
501 print(msg.as_string(False))
505 notmuch_debug_sanitize () {
509 notmuch_exception_sanitize () {
510 perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
513 notmuch_search_sanitize () {
514 notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
517 notmuch_search_files_sanitize () {
521 notmuch_dir_sanitize () {
522 sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
525 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
526 notmuch_show_sanitize () {
527 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
529 notmuch_show_sanitize_all () {
530 notmuch_debug_sanitize | \
532 -e 's| filename:.*| filename:XXXXX|' \
533 -e 's| id:[^ ]* | id:XXXXX |' | \
534 notmuch_date_sanitize
537 notmuch_json_show_sanitize () {
539 -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
540 -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
541 -e 's|"filename": "signature.asc",||g' \
542 -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
543 -e 's|"timestamp": 97.......|"timestamp": 42|g' \
544 -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
547 notmuch_emacs_error_sanitize () {
553 notmuch_debug_sanitize < "$file"
557 -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
560 notmuch_date_sanitize () {
562 -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
565 notmuch_uuid_sanitize () {
566 sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
569 notmuch_built_with_sanitize () {
570 sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
573 notmuch_config_sanitize () {
574 notmuch_dir_sanitize | notmuch_built_with_sanitize
577 notmuch_show_part () {
578 awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
581 # End of notmuch helper functions
583 # Use test_set_prereq to tell that a particular prerequisite is available.
585 # The prerequisite can later be checked for by using test_have_prereq.
587 # The single parameter is the prerequisite tag (a simple word, in all
588 # capital letters by convention).
591 satisfied="$satisfied$1 "
595 test_have_prereq () {
604 declare -A test_missing_external_prereq_
605 declare -A test_subtest_missing_external_prereq_
607 # declare prerequisite for the given external binary
608 test_declare_external_prereq () {
611 test "$#" = 2 && name=$2 || name="$binary(1)"
613 if ! hash $binary 2>/dev/null; then
614 test_missing_external_prereq_["${binary}"]=t
617 test_subtest_missing_external_prereq_[\"${name}\"]=t
623 # Explicitly require external prerequisite. Useful when binary is
624 # called indirectly (e.g. from emacs).
625 # Returns success if dependency is available, failure otherwise.
626 test_require_external_prereq () {
629 if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
630 # dependency is missing, call the replacement function to note it
637 # You are not expected to call test_ok_ and test_failure_ directly, use
638 # the text_expect_* functions instead.
641 if test "$test_subtest_known_broken_" = "t"; then
642 test_known_broken_ok_
645 test_success=$(($test_success + 1))
646 if test -n "$NOTMUCH_TEST_QUIET"; then
649 say_color pass "%-6s" "PASS"
650 echo " $test_subtest_name"
654 print_test_description
655 if test "$test_subtest_known_broken_" = "t"; then
656 test_known_broken_failure_ "$@"
659 test_failure=$(($test_failure + 1))
660 test_failure_message_ "FAIL" "$test_subtest_name" "$@"
661 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
665 test_failure_message_ () {
666 say_color error "%-6s" "$1"
669 if [ "$#" != "0" ]; then
670 echo "$@" | sed -e 's/^/ /'
672 if test "$verbose" != "t"; then cat test.output; fi
675 test_known_broken_ok_ () {
677 test_fixed=$(($test_fixed+1))
678 say_color pass "%-6s" "FIXED"
679 echo " $test_subtest_name"
682 test_known_broken_failure_ () {
684 test_broken=$(($test_broken+1))
685 if [ -z "$NOTMUCH_TEST_QUIET" ]; then
686 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
688 test_failure_message_ "BROKEN" "$test_subtest_name"
694 test "$debug" = "" || eval "$1"
699 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
702 eval >&3 2>&4 "$test_cleanup"
707 test_count=$(($test_count+1))
709 for skp in $NOTMUCH_SKIP_TESTS
711 case $this_test.$test_count in
716 case $this_test_bare.$test_count in
724 test_report_skip_ "$@"
727 test_check_missing_external_prereqs_ "$@"
732 test_check_missing_external_prereqs_ () {
733 if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
734 say_color skip >&1 "missing prerequisites: "
735 echo ${!test_subtest_missing_external_prereq_[@]} >&1
736 test_report_skip_ "$@"
742 test_report_skip_ () {
744 say_color skip >&3 "skipping test:"
746 say_color skip "%-6s" "SKIP"
750 test_subtest_known_broken () {
751 test_subtest_known_broken_=t
754 test_expect_success () {
755 exec 1>&6 2>&7 # Restore stdout and stderr
756 if [ -z "$inside_subtest" ]; then
757 error "bug in the test script: test_expect_success without test_begin_subtest"
761 error "bug in the test script: not 1 parameters to test_expect_success"
763 if ! test_skip "$test_subtest_name"
767 # test_run_ may update missing external prerequisites
768 test_check_missing_external_prereqs_ "$test_subtest_name" ||
769 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
778 test_expect_code () {
779 exec 1>&6 2>&7 # Restore stdout and stderr
780 if [ -z "$inside_subtest" ]; then
781 error "bug in the test script: test_expect_code without test_begin_subtest"
785 error "bug in the test script: not 2 parameters to test_expect_code"
787 if ! test_skip "$test_subtest_name"
791 # test_run_ may update missing external prerequisites,
792 test_check_missing_external_prereqs_ "$test_subtest_name" ||
793 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
797 test_failure_ "exit code $eval_ret, expected $1" "$2"
802 # This is not among top-level (test_expect_success)
803 # but is a prefix that can be used in the test script, like:
805 # test_expect_success 'complain and die' '
807 # do something else &&
808 # test_must_fail git checkout ../outerspace
811 # Writing this as "! git checkout ../outerspace" is wrong, because
812 # the failure could be due to a segv. We want a controlled failure.
816 test $? -gt 0 -a $? -le 129 -o $? -gt 192
819 # test_cmp is a helper function to compare actual and expected output.
820 # You can use it like:
822 # test_expect_success 'foo works' '
823 # echo expected >expected &&
825 # test_cmp expected actual
828 # This could be written as either "cmp" or "diff -u", but:
829 # - cmp's output is not nearly as easy to read as diff -u
830 # - not all diff versions understand "-u"
836 # This function can be used to schedule some commands to be run
837 # unconditionally at the end of the test to restore sanity:
839 # test_expect_success 'test core.capslock' '
840 # git config core.capslock true &&
841 # test_when_finished "git config --unset core.capslock" &&
845 # That would be roughly equivalent to
847 # test_expect_success 'test core.capslock' '
848 # git config core.capslock true &&
850 # git config --unset core.capslock
853 # except that the greeting and config --unset must both succeed for
856 test_when_finished () {
858 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
863 test_results_dir="$TEST_DIRECTORY/test-results"
864 test -d "$test_results_dir" || mkdir "$test_results_dir"
865 test_results_path="$test_results_dir/$this_test"
868 "success $test_success" \
869 "fixed $test_fixed" \
870 "broken $test_broken" \
871 "failed $test_failure" \
872 "total $test_count" \
875 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
877 if [ "$test_failure" = "0" ]; then
878 if [ "$test_broken" = "0" ]; then
888 # Note: if there is need to print debug information from python program,
889 # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
890 PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
891 $NOTMUCH_PYTHON -B - > OUTPUT
895 local exec_file test_file
896 exec_file="test${test_count}"
897 test_file="${exec_file}.c"
899 ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
900 echo "== stdout ==" > OUTPUT.stdout
901 echo "== stderr ==" > OUTPUT.stderr
902 ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
903 notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
907 local base_name test_file shim_file
909 test_file="${base_name}.c"
910 shim_file="${base_name}.so"
912 ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
915 notmuch_with_shim () {
916 local base_name shim_file
919 shim_file="${base_name}.so"
920 LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
923 # Creates a script that counts how much time it is executed and calls
924 # notmuch. $notmuch_counter_command is set to the path to the
925 # generated script. Use notmuch_counter_value() function to get the
926 # current counter value.
927 notmuch_counter_reset () {
928 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
929 if [ ! -x "$notmuch_counter_command" ]; then
930 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
931 cat >"$notmuch_counter_command" <<EOF || return
934 read count < "$notmuch_counter_state_path"
935 echo \$((count + 1)) > "$notmuch_counter_state_path"
939 chmod +x "$notmuch_counter_command" || return
942 echo 0 > "$notmuch_counter_state_path"
945 # Returns the current notmuch counter value.
946 notmuch_counter_value () {
947 if [ -r "$notmuch_counter_state_path" ]; then
948 read count < "$notmuch_counter_state_path"
955 test_reset_state_ () {
956 test -z "$test_init_done_" && test_init_
958 test_subtest_known_broken_=
959 test_subtest_missing_external_prereq_=()
962 # called once before the first subtest
966 # skip all tests if there were external prerequisites missing during init
967 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
971 # Where to run the tests
972 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
974 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
976 # Use -P to resolve symlinks in our working directory so that the cwd
977 # in subprocesses like git equals our $PWD (for pathname comparisons).
978 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
980 if test "$verbose" = "t"
984 exec 4>test.output 3>&4
987 for skp in $NOTMUCH_SKIP_TESTS
990 for skp in $NOTMUCH_SKIP_TESTS
997 case "$this_test_bare" in
1005 say_color skip >&3 "skipping test $this_test altogether"
1006 say_color skip "skip all tests in $this_test"
1011 # Provide an implementation of the 'yes' utility
1026 # Fix some commands on Windows
1029 # Windows has its own (incompatible) sort and find
1039 # git sees Windows-style pwd
1043 # no POSIX permissions
1044 # backslashes in pathspec are converted to '/'
1045 # exec does not inherit the PID
1048 test_set_prereq POSIXPERM
1049 test_set_prereq BSLASHPSPEC
1050 test_set_prereq EXECKEEPSPID
1054 test -z "$NO_PERL" && test_set_prereq PERL
1055 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1057 # test whether the filesystem supports symbolic links
1058 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1061 # declare prerequisites for external binaries used in tests
1062 test_declare_external_prereq dtach
1063 test_declare_external_prereq emacs
1064 test_declare_external_prereq ${TEST_EMACSCLIENT}
1065 test_declare_external_prereq ${TEST_GDB}
1066 test_declare_external_prereq gpg
1067 test_declare_external_prereq openssl
1068 test_declare_external_prereq gpgsm
1069 test_declare_external_prereq ${NOTMUCH_PYTHON}
1070 test_declare_external_prereq xapian-metadata
1071 test_declare_external_prereq xapian-delve